% Nom du fichier : mef.m
% 
% Script faisant appel aux diffrentes fonction permettant de construire unMEF 
% 
% DESCRIPTION GENERALE
% - Fonction permettant d'valuer les dformations mcaniques (HPP) d'un tissu de
%   forme rectangulaire sur lequel agit une pression ou un dplacement
%   impos
% - Dformations planes 
% - Mthode des lments finis
% - Elments utiliss type plane42 d'ANSYS (fonction d'interpolation
% linaire, lment rectangulaire)
% 
%mmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmm


% mef

%mmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmm
% Gomtrie :
% l, Longueur du cot horizontal (selon X) du carr :
% h, Longueur du cot vertical (selon Y) du carr :
l=1;
h=1;

%mmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmm
% Maillage :
ne1 = 51; % Nbre d'lments sur le ct
ne = [ne1,ne1]; % Nombre d'lments sur les 2 cts du rectangle (doit tre le mme)
[Tnn,Tne,Tc,te,Xe,Ye]=maillage_rectangle(l,h,ne); % Tables de connectivit, maillage
% On peut tracer ici le maillge (mesh).

%mmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmm
% Comportement matriau local (comportement spcifique sur chaque maille) :
% Chaque maille a son propre module de Young
E = 100*ones(ne); % Module de Young kPa
%% Cas d'une ligne centrale :
%E(fix(ne1/2)+1-(fix(ne1/5)-1):fix(ne1/2)+1+(fix(ne1/5)-1),1:ne1)=10; % kPa
%% Cas d'une inclusion rectangulaire :
E(fix(ne1/2)+1-(fix(ne1/5)-1):fix(ne1/2)+1+(fix(ne1/5)-1),fix(ne1/2)+1-(fix(ne1/5)-1):fix(ne1/2)+1+(fix(ne1/5)-1))=10; % kPa
Nu=0.49; % Coefficient de Poisson
% On peut tracer ici la cartographie du module de Young.

%mmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmm
% Matrice lmentaire et assemblage de la matrice de raideur gnrale :
[Kg,E,Nu]=construction_matrice_rigidite(E,Nu,ne,Tc,l,h);
% Attention changement de taille de E, cartographie des modules de Young en
% vecteur ici...
% On peut visualiser les bandes de la matrice Kg ici (spy(Kg))

%mmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmm
% Conditions aux limites :
[U,F]=conditions_limites(Tnn,l,h,ne);

%mmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmm
% Resolution :
[U,F,Ux,Uy,Fx,Fy]=resolution(Kg,U,F);

%mmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmm
% Post-traitement:
post_traitement(Ux,Uy,Fx,Fy,Tc,te,Tnn,E,Nu,Xe,Ye,ne);

% Fin
